#include <iostream>

namespace my_std {
template<typename T>
struct vector {
	struct iterator {};
	iterator begin() { return {}; }
	iterator end() { return {}; }
};

template<typename I>
void algo(I /*begin*/, I /*end*/) {
	std::cout << "Calling my_std::algo\n";
}
} // namespace my_std

namespace my_std::ranges {
template<typename I, typename S>
void algo(I /*begin*/, S /*sentinel*/) {
	std::cout << "Calling my_std::ranges::algo\n";
}
} // namespace my_std::ranges

int main() {
	my_std::vector<int> x;
	using namespace my_std::ranges;
	algo(x.begin(), x.end());
}
