#include <iostream>

template <typename Self>
struct Eq {
	friend bool operator!=(const Self& a, const Self& b) {
		return !(a == b);
	}
};

struct Num : Eq<Num> {
	Num(int value) : value(value) {}
	int value;
	friend bool operator==(const Num& a, const Num& b) {
		return a.value == b.value;
	}
};

int main() {
	Num x = 10;
	Num y = 17;
	std::cout << std::boolalpha << (x != y) << '\n';
}
